<template>
    <table id="datatable-buttons" class="table table-striped table-bordered">
        <thead>
            <tr>
                <th>#</th>
                <th>Banco</th>
                <th># de cuenta</th>
                <th>T. de cuenta</th>
                <th>Propietario</th>
                <th>Documento</th>

                <th>Acciones</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="(item, i) in banco" :key="item.id">
                <td>{{ i + 1 }}</td>
                <td>{{ item.name_banco }}</td>
                <td>{{ item.numero_cuenta }}</td>
                <td>{{ item.tipo_cuenta }}</td>
                <td>{{ item.nombre_persona }}</td>

                <!-- status -->
                <td>{{ item.documento_type + "-" + item.documento }}</td>
                <!-- fin de estatus -->

                <td>
                    <div
                        class="tabledit-toolbar btn-toolbar"
                        style="text-align: center;"
                    >
                        <div
                            class="btn-group btn-group-sm"
                            style="float: none;"
                        >
                            <button
                                type="button"
                                class="tabledit-edit-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                v-bind:data-target="'#editModal' + item.id"
                            >
                                <span class="ti-pencil"></span>
                            </button>
                            <button
                                type="button"
                                class="tabledit-delete-button btn btn-sm btn-info"
                                style="float: none; margin: 5px;"
                                data-toggle="modal"
                                v-bind:data-target="'#deleteModal' + item.id"
                            >
                                <span class="ti-trash"></span>
                            </button>
                        </div>
                    </div>
                </td>
                <!-- editar -->
                <div
                    class="modal fade"
                    v-bind:id="'editModal' + item.id"
                    tabindex="-1"
                    role="dialog"
                    v-bind:aria-labelledby="'editModalLabel' + item.id"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="editModalLabel">
                                    Editar cuenta bancaria
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form
                                    v-bind:id="'form-' + item.id"
                                    method="POST"
                                    v-on:submit.prevent="updateBanco(item)"
                                >
                                    <div
                                        v-if="error"
                                        id="errorAlert"
                                        class="alert alert-danger alert-dismissible fade show"
                                        role="alert"
                                    >
                                        <strong>Ohh no!</strong> {{ error }}.
                                        <button
                                            type="button"
                                            class="close"
                                            v-on:click.prevent="closeAlert()"
                                            aria-label="Close"
                                        >
                                            <span aria-hidden="true"
                                                >&times;</span
                                            >
                                        </button>
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="text"
                                            placeholder="Ingrese el nombre del banco"
                                            class="form-control "
                                            name="name_banco"
                                            v-model="item.name_banco"
                                            required
                                            autocomplete="name_banco"
                                            autofocus
                                        />
                                    </div>
                                    <div class="form-group">
                                        <select
                                            name="tipo_cuenta"
                                            class="form-control "
                                            v-model="item.tipo_cuenta"
                                            required
                                            autofocus
                                            placeholder="Seleccione el tipo de cuenta"
                                        >
                                            <option selected disabled value="">
                                                Seleccione el tipo de cuenta
                                            </option>
                                            <option value="corriente"
                                                >Cuenta Corriente</option
                                            >
                                            <option value="ahorro"
                                                >Cuenta de Ahorro</option
                                            >
                                        </select>
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="string"
                                            placeholder="Ingrese el numero de cuenta a registrar"
                                            class="form-control"
                                            name="numero_cuenta"
                                            v-model="item.numero_cuenta"
                                            required
                                            autocomplete="numero_cuenta"
                                        />
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="text"
                                            placeholder="Ingrese el nombre del propietario de la cuenta"
                                            class="form-control"
                                            name="nombre_persona"
                                            v-model="item.nombre_persona"
                                            required
                                            autocomplete="nombre_persona"
                                        />
                                    </div>
                                    <div class="form-group">
                                        <div class="input-group mb-3">
                                            <div class="input-group-prepend">
                                                <select
                                                    class="form-control"
                                                    name="documento_type"
                                                    v-model="
                                                        item.documento_type
                                                    "
                                                >
                                                    <option
                                                        selected
                                                        disabled
                                                        value=""
                                                    >
                                                        -
                                                    </option>
                                                    <option value="J">J</option>
                                                    <option value="V">V</option>
                                                    <option value="E">E</option>
                                                </select>
                                            </div>
                                            <input
                                                type="text"
                                                class="form-control"
                                                placeholder="Ingrese el numero de documento"
                                                v-model="item.documento"
                                            />
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <input
                                            type="email"
                                            placeholder="ingrese correo de confirmación para el banco"
                                            class="form-control"
                                            name="email"
                                            v-model="item.email"
                                            required
                                            autocomplete="email"
                                        />
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-secondary"
                                    data-dismiss="modal"
                                >
                                    Close
                                </button>
                                <button
                                    v-on:click.prevent="updateBanco(item)"
                                    type="button"
                                    class="btn btn-primary"
                                    :id="'edit-' + item.id"
                                >
                                    Guardar cambios
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- fin editar -->
                <!-- eliminar -->
                <div
                    class="modal fade"
                    v-bind:id="'deleteModal' + item.id"
                    tabindex="-1"
                    role="dialog"
                    v-bind:aria-labelledby="'deleteModalLabel' + item.id"
                    aria-hidden="true"
                >
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header bg-danger">
                                <h5
                                    class="modal-title "
                                    v-bind:id="'deleteModalLabel' + item.id"
                                >
                                    Eliminar cuenta bancaria
                                </h5>
                                <button
                                    type="button"
                                    class="close"
                                    data-dismiss="modal"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <p class="text-muted">
                                    ¿Seguro desea eliminar la cuenta del

                                    <b> {{ item.name_banco }}</b
                                    >?
                                </p>
                            </div>
                            <div class="modal-footer">
                                <button
                                    type="button"
                                    class="btn btn-secondary"
                                    data-dismiss="modal"
                                >
                                    Cancelar
                                </button>
                                <button
                                    type="button"
                                    class="btn btn-danger"
                                    v-on:click.prevent="deleteBank(item.id)"
                                >
                                    Eliminar Cuenta Bancaria
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- fin de eliminar -->
            </tr>
        </tbody>
        <!-- crear usuario -->
        <div
            class="modal fade"
            id="crearModal"
            tabindex="-1"
            role="dialog"
            aria-labelledby="crearModalLabel"
            aria-hidden="true"
        >
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="crearModalLabel">
                            Agregar nueva cuenta bancaria
                        </h5>
                        <button
                            type="button"
                            class="close"
                            data-dismiss="modal"
                            aria-label="Close"
                        >
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form method="POST">
                            <!-- Alerta de error -->
                            <div
                                v-if="error"
                                id="errorAlert"
                                class="alert alert-danger alert-dismissible fade show"
                                role="alert"
                            >
                                <strong>Ohh no!</strong> {{ error }}.
                                <button
                                    type="button"
                                    class="close"
                                    v-on:click.prevent="closeAlert()"
                                    aria-label="Close"
                                >
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <!-- fin de error -->
                            <div class="form-group">
                                <input
                                    type="text"
                                    placeholder="Ingrese el nombre del banco"
                                    class="form-control "
                                    name="name_banco"
                                    v-model="newBanco.name_banco"
                                    required
                                    autocomplete="name_banco"
                                    autofocus
                                />
                            </div>
                            <div class="form-group">
                                <select
                                    name="tipo_cuenta"
                                    class="form-control "
                                    v-model="newBanco.tipo_cuenta"
                                    required
                                    autofocus
                                    placeholder="Seleccione el tipo de cuenta"
                                >
                                    <option selected disabled value="">
                                        Seleccione el tipo de cuenta
                                    </option>
                                    <option value="corriente"
                                        >Cuenta Corriente</option
                                    >
                                    <option value="ahorro"
                                        >Cuenta de Ahorro</option
                                    >
                                </select>
                            </div>
                            <div class="form-group">
                                <input
                                    type="string"
                                    placeholder="Ingrese el numero de cuenta a registrar"
                                    class="form-control"
                                    name="numero_cuenta"
                                    v-model="newBanco.numero_cuenta"
                                    required
                                    autocomplete="numero_cuenta"
                                />
                            </div>
                            <div class="form-group">
                                <input
                                    type="text"
                                    placeholder="Ingrese el nombre del propietario de la cuenta"
                                    class="form-control"
                                    name="nombre_persona"
                                    v-model="newBanco.nombre_persona"
                                    required
                                    autocomplete="nombre_persona"
                                />
                            </div>
                            <div class="form-group">
                                <div class="input-group mb-3">
                                    <div class="input-group-prepend">
                                        <select
                                            class="form-control"
                                            name="documento_type"
                                            v-model="newBanco.documento_type"
                                        >
                                            <option selected disabled value="">
                                                -
                                            </option>
                                            <option value="J">J</option>
                                            <option value="V">V</option>
                                            <option value="E">E</option>
                                        </select>
                                    </div>
                                    <input
                                        type="text"
                                        class="form-control"
                                        placeholder="Ingrese el numero de documento"
                                        v-model="newBanco.documento"
                                    />
                                </div>
                            </div>
                            <div class="form-group">
                                <input
                                    type="email"
                                    placeholder="ingrese correo de confirmación para el banco"
                                    class="form-control"
                                    name="email"
                                    v-model="newBanco.email"
                                    required
                                    autocomplete="email"
                                />
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button
                            type="button"
                            class="btn btn-secondary"
                            data-dismiss="modal"
                        >
                            Close
                        </button>
                        <button
                            v-on:click.prevent="createBank()"
                            type="button"
                            class="btn btn-primary"
                            id="submit"
                        >
                            Crear
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <!-- fin crear usuario -->
    </table>
</template>

<script>
export default {
    props: ["bancos"],
    created: function() {},
    mounted() {},
    data() {
        return {
            banco: this.bancos,
            newBanco: {
                name_banco: "",
                tipo_cuenta: "",
                numero_cuenta: "",
                nombre_persona: "",
                documento: "",
                documento_type: "",
                email: ""
            },
            error: "",
            url: "/api/config/bancos"
        };
    },
    methods: {
        get: function() {
            axios.get(this.url).then(res => {
                this.banco = res.data;
            });
        },
        ver(e) {
            location.href = "/dashboard/compras/plantilla/" + e;
        },
        createBank() {
            $("#submit").attr("disabled", true);
            let banco = this.newBanco;
            if (
                this.newBanco.name_banco &&
                this.newBanco.tipo_cuenta &&
                this.newBanco.numero_cuenta &&
                this.newBanco.nombre_persona &&
                this.newBanco.documento &&
                this.newBanco.documento_type &&
                this.newBanco.email
            ) {
                if (
                    Number.isInteger(Number(this.newBanco.documento)) &&
                    Number.isInteger(Number(this.newBanco.numero_cuenta))
                ) {
                    axios.post(this.url, banco).then(res => {
                        this.get();
                        $("#crearModal").modal("toggle");
                        $(".modal-backdrop").remove();
                        $("#submit").attr("disabled", false);
                    });
                } else {
                    this.error =
                        "Recuerde que los números de cuenta y documento deben ser solo númericos, debe evitar usar carácteres especiales y/0 letras en estos campos";
                    $("#submit").attr("disabled", false);
                }
            } else {
                this.error =
                    "Para continuar debe completar todos los campos requeridos";
                $("#submit").attr("disabled", false);
            }
        },
        updateBanco(item) {
            $("#edit" + item.id).attr("disabled", true);

            if (
                item.name_banco &&
                item.tipo_cuenta &&
                item.numero_cuenta &&
                item.nombre_persona &&
                item.documento &&
                item.documento_type &&
                item.email
            ) {
                if (
                    Number.isInteger(Number(item.documento)) &&
                    Number.isInteger(Number(item.numero_cuenta))
                ) {
                    axios.put(this.url + "/" + item.id, item).then(res => {
                        this.get();
                        $("#editModal" + item.id).modal("toggle");
                        $(".modal-backdrop").remove();
                        $("#edit" + item.id).attr("disabled", false);
                    });
                } else {
                    this.error =
                        "Recuerde que los números de cuenta y documento deben ser solo númericos, debe evitar usar carácteres especiales y/0 letras en estos campos";
                    $("#edit" + item.id).attr("disabled", false);
                }
            } else {
                this.error =
                    "Para continuar debe completar todos los campos requeridos";
                $("#edit" + item.id).attr("disabled", false);
            }
        },
        deleteBank(i) {
            axios.delete(this.url + "/" + i).then(res => {
                this.get();
                $("#deleteModal" + i.id).modal("toggle");
                $(".modal-backdrop").remove();
            });
        },
        closeAlert() {
            this.error = "";
        }
    }
};
</script>
